;=========================================================
;	ET199_ Run-time Package installer script.
;=========================================================


;!define _LANG_ENGLISH_    ;Ӣİʱȥעͣע͵
!define _LANG_SIMPCHINESE_ ;İʱȥעͣע͵Ӣ


!define _OEM_NAME		"std"
!define _OEM_STD
!define PRODUCT_GUID		"ET199-BACEF725-DF0B-4622-BE56-29A5A0C855C6_std"

!define TARGET_REG_BASE		"Software\${COMPANY_NAME}\ET199"
!define TARGET_REG_ROOT		$(STR_STARTMENU_BASE)
!define TARGET_DIR_BASE		"$(STR_STARTMENU_BASE)\ET199"
!define START_MENU_ROOT		$(STR_STARTMENU_BASE)

!define COMPANY_NAME		"EnterSafe"
!define COPYRIGHT		"Copyright(C) 2004-2007, ${COMPANY_NAME}"
!define PRODUCT_NAME		"ET199"
!define TITLE_NAME		"EnterSafe (For ET199)"
!define PRODUCT_DESC		"EnterSafe (For ET199) Middleware"
!define PRODUCT_VER		"1.0"
!define FILE_VER		"1.0.7.905"
!define VER_MAJO		1
!define VER_MINOR		0
!define SRC_RC_PATH		"rc"
!define SRC_APPS_PATH		"apps"

!ifndef _OEM_NAME
	!error "You must define the _OEM_NAME."
!endif

;--------------------------------------
; Զ
;--------------------------------------

!ifdef _LANG_ENGLISH_
	!define _LANG				1033
	!define _LANG_NAME			"English"
!else ifdef _LANG_SIMPCHINESE_
	!define _LANG				2052
	!define _LANG_NAME			"SimpChinese"
!else
	!define _LANG				1033
	!define _LANG_NAME			""
	!define _LANG_ALL
!endif

;--------------------------------------
; ȰװԻҪõͷļ
;--------------------------------------
!include "MUI.nsh"

;--------------------------------------
; nsiűļ
;--------------------------------------
OutFile "ET199-${_LANG_NAME}.exe"

Name "${PRODUCT_NAME}"

;--------------------------------------
; 尲װİ汾Ϣ[ѡ]
;--------------------------------------
VIProductVersion ${FILE_VER}
VIAddVersionKey /LANG=${_LANG} "CompanyName"		"${COMPANY_NAME}"
VIAddVersionKey /LANG=${_LANG} "ProductName"		"${PRODUCT_NAME}"
VIAddVersionKey /LANG=${_LANG} "LegalCopyright"		"${COPYRIGHT}"
VIAddVersionKey /LANG=${_LANG} "FileDescription"	"${PRODUCT_DESC}"
VIAddVersionKey /LANG=${_LANG} "FileVersion"		"${FILE_VER}"

;--------------------------------------
; Ĭϰװ·
;--------------------------------------
InstallDir "$PROGRAMFILES\${TARGET_DIR_BASE}"

;--------------------------------------
; Ĭעֵ
;--------------------------------------
InstallDirRegKey HKLM "${TARGET_REG_BASE}" ""

;--------------------------------------
; ðװжضԻԴ
;--------------------------------------
!define MUI_UNICON		"${SRC_RC_PATH}\uninstall.ico"
!define MUI_ICON		"${SRC_RC_PATH}\install.ico"



!define MUI_WELCOMEFINISHPAGE_BITMAP	"${SRC_RC_PATH}\win_inst.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP	"${SRC_RC_PATH}\win_uninst.bmp"


!define MUI_HEADERIMAGE             ; Use the header image
!define MUI_HEADERIMAGE_RIGHT		; Put the header image to right.

!define MUI_HEADERIMAGE_BITMAP		"${SRC_RC_PATH}\header_inst.bmp"
!define MUI_HEADERIMAGE_UNBITMAP	"${SRC_RC_PATH}\header_uninst.bmp"



;--------------------------------------
; װжصĹоʾϸϢ
;--------------------------------------
ShowInstDetails "nevershow"
ShowUninstDetails "nevershow"
;SilentInstall silent
;
;--------------------------------------
;װж˳ǰ
;--------------------------------------
!define MUI_ABORTWARNING
!define MUI_UNABORTWARNING

;סװѡõԣжسпõ
!define MUI_LANGDLL_REGISTRY_ROOT		"HKLM"
!define MUI_LANGDLL_REGISTRY_KEY		"${TARGET_REG_BASE}"
!define MUI_LANGDLL_REGISTRY_VALUENAME	"LanguageId"
!define MUI_COMPONENTSPAGE_SMALLDESC

;--------------------------------
;һЩ
;--------------------------------
Var VAR_0
Var VAR_1
Var VAR_2
;--------------------------------------
; 尲װԻ
;--------------------------------------
; Installer Pages.
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH  

;--------------------------------------
; жضԻ
;--------------------------------------
!insertmacro MUI_UNPAGE_WELCOME
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH

;--------------------------------------
; ֧
;--------------------------------------

!ifdef _LANG_SIMPCHINESE_

 !ifndef LANG_SIMPCHINESE
	 !define LANG_SIMPCHINESE		2052
 !endif

 !insertmacro MUI_LANGUAGE "SimpChinese"

 LangString STR_ALREADY_INSTALLED		${LANG_SIMPCHINESE} "${PRODUCT_NAME}Ѿڱϰװˡ$\n$\nǷƳ${PRODUCT_NAME}"
 LangString STR_UNINSTALLER_NAME			${LANG_SIMPCHINESE} "${PRODUCT_NAME} (Ƴ)"
 LangString STR_LINK_MANAGER			${LANG_SIMPCHINESE} "ET199"
 LangString STR_LINK_CONFIG                     ${LANG_SIMPCHINESE} "ET199ù"
 LangString STR_STARTMENU_BASE			${LANG_SIMPCHINESE} "${COMPANY_NAME}"
 LangString STR_LINK_UNINSTALLER			${LANG_SIMPCHINESE} "жET199"
 LangString STR_CHECK_ADMIN				${LANG_SIMPCHINESE} "ֻʹùԱʻװ"
 LangString STR_INSTALL_DRV				${LANG_SIMPCHINESE} "ڰװ${PRODUCT_NAME}..."
 
!endif


!ifdef _LANG_ENGLISH_
  
 !ifndef LANG_ENGLISH
	 !define LANG_ENGLISH			1033
 !endif

 !insertmacro MUI_LANGUAGE "English"
 
 LangString STR_ALREADY_INSTALLED		${LANG_ENGLISH} "${PRODUCT_NAME} is already installed.$\n$\nDo you want to remove ${PRODUCT_NAME} now?"
 LangString STR_UNINSTALLER_NAME			${LANG_ENGLISH} "${PRODUCT_NAME} (Remove only)"
 LangString STR_LINK_MANAGER				${LANG_ENGLISH} "Token Manager"
 LangString STR_STARTMENU_BASE			${LANG_ENGLISH} "${COMPANY_NAME}"
 LangString STR_LINK_UNINSTALLER			${LANG_ENGLISH} "Uninstall"
 LangString STR_CHECK_ADMIN				${LANG_ENGLISH} "Only use administrator account,you can Install this software properly. "
 LangString STR_INSTALL_DRV				${LANG_ENGLISH} "Installing ${PRODUCT_NAME} driver..."
  
!endif

;--------------------------------
;Reserve Files

;These files should be inserted before other files in the data block
;Keep these lines before any File command
;Only for BZIP2 (solid) compression
ReserveFile "${SRC_RC_PATH}\header_inst.bmp"


;--------------------------------
; װʼ
;--------------------------------
Function .onInit
	SetOverwrite try

	;----------------------------------------------------------------
	; ǷǹԱ
	;----------------------------------------------------------------
	ClearErrors
	UserInfo::GetName
	IfErrors OnWin9X
	Pop $0
	UserInfo::GetAccountType
	Pop $1
	StrCmp $1 "Admin" OnInitOk OnInitErr
	
	OnInitErr:
	MessageBox MB_OK $(STR_CHECK_ADMIN)
	Abort
	
	OnWin9X:
	;Abort
	
    ; We create shortcuts to All users not Current User
	OnInitOk:
	SetShellVarContext all
	;Abort

	;------------------------------------
	; 2: ɰ汾
	;------------------------------------
	ReadRegStr $VAR_0 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_GUID}" "UninstallString"
	StrCmp $VAR_0 "" +1 Label_Uninstall

	goto Label_NotInstalled

Label_Uninstall:
	MessageBox MB_YESNO|MB_ICONQUESTION $(STR_ALREADY_INSTALLED) IDNO Label_NotUninstall
		Exec $VAR_0
			Abort

	Label_NotUninstall:
		abort
Label_NotInstalled:
StrCpy $LANGUAGE "${_LANG}"

FunctionEnd

;=================================================================
; װ: 1. 2. 3. 4
;=================================================================
Section

	CreateDirectory "$INSTDIR"

	;------------------------------------
	; 1: жس
	;------------------------------------
	WriteUninstaller "$INSTDIR\uninst.exe"

	;------------------------------------
	; 2: Win98 HID 
	;------------------------------------
	Call InstHIDDrv
	;------------------------------------
	; 3: װм
	;------------------------------------
	WriteRegStr HKLM "${TARGET_REG_BASE}" "Path" $INSTDIR
	WriteRegStr HKLM "${TARGET_REG_BASE}" "LanguageId" $LANGUAGE
	WriteRegStr HKLM "${TARGET_REG_BASE}" "Version" ${PRODUCT_VER}

	Call InstMW
	
	;------------------------------------
	; 4: дע
	;------------------------------------
	; uninstall strings
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_GUID}" "DisplayName" $(STR_UNINSTALLER_NAME)
	WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_GUID}" "UninstallString" '"$INSTDIR\uninst.exe"'

SectionEnd

;--------------------------------
; жسʼ
;--------------------------------
Function un.onInit
	ReadRegStr $LANGUAGE HKLM "${TARGET_REG_BASE}" "LanguageId"
	
	;----------------------------------------------------------------
	; ǷҪ
	;----------------------------------------------------------------
	
	Push $R0
	Push $R1
	
	ReadRegStr $R0 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion" CurrentVersion
	;----------------------------------------------------------------
	; ǷǹԱ
	;----------------------------------------------------------------
	ClearErrors
	UserInfo::GetName
	IfErrors OnWin9X
	Pop $0
	UserInfo::GetAccountType
	Pop $1
	StrCmp $1 "Admin" OnInitOk OnInitErr
	
	OnInitErr:
	MessageBox MB_OK $(STR_CHECK_ADMIN)
	Abort
	
	OnWin9X:
	;Abort
	
    ; We create shortcuts to All users not Current User
	OnInitOk:
	SetShellVarContext all
	;Abort
FunctionEnd

;=================================================================
; ж: 1, 2
;=================================================================
Section "Uninstall"
	;------------------------------------
	; 1: жм
	;------------------------------------
	Call un.InstMW

	;------------------------------------
	; 2: ɾעĿ¼
	;------------------------------------
	DeleteRegKey HKLM "${TARGET_REG_BASE}"
	DeleteRegKey /ifempty HKLM "Software\${TARGET_REG_ROOT}"
	DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\${PRODUCT_GUID}"

	Delete "$INSTDIR\uninst.exe"

	; Loop to remove the $INSTDIR.
	StrCpy $VAR_0 "$INSTDIR\.."

	instDirDeleteLoop:
		StrCpy $VAR_1 $VAR_0
		GetFullPathName $VAR_0 "$VAR_1\.."

		ClearErrors
		RMDir $VAR_1
		IfErrors instDirDeleteDone 
		StrCpy $VAR_2 $VAR_0 2 -2
		StrCmp $VAR_2 ":\" instDirDeleteDone instDirDeleteLoop

		instDirDeleteDone:

SectionEnd

;-------------------------------------------------
; װWin98 HID ĺ
;-------------------------------------------------
Function InstHIDDrv
	SetPluginUnload  alwaysoff

	SetDetailsPrint textonly
	DetailPrint ""
	SetDetailsPrint listonly

	SetOutPath $SYSDIR
	SetOverwrite off
	File "${SRC_APPS_PATH}\MSVCP60.DLL"

	SetOutPath $TEMP
	File       ${SRC_APPS_PATH}\RegHidDevice.dll

	SetDetailsPrint textonly
	DetailPrint $(STR_INSTALL_DRV)
	SetDetailsPrint listonly
	StrCpy $0 "VID_096E&PID_0304;12"
 	System::Call 'RegHidDevice.dll::WriteRegForHidDeviceFor98(t) i(r0.).r1'
FunctionEnd

;-------------------------------------------------
; װмĺ
;-------------------------------------------------
Function InstMW

	SetOutPath $INSTDIR
	SetOverwrite try

	File "${SRC_APPS_PATH}\et199csp11_s.reg"
	File "${SRC_APPS_PATH}\escertd_et199.exe"
	File "${SRC_APPS_PATH}\esmgr_et199.exe"
	File "${SRC_APPS_PATH}\ConfigTool_et199.exe"
	File "${SRC_APPS_PATH}\et199.ini"
	CreateDirectory  "$INSTDIR\lang"
	SetOutPath "$INSTDIR\lang"
	File "${SRC_APPS_PATH}\lang\esmgr_1033.lng"
	File "${SRC_APPS_PATH}\lang\esmgr_2052.lng"
	File "${SRC_APPS_PATH}\lang\escertd_1033.lng"
	File "${SRC_APPS_PATH}\lang\escertd_2052.lng"
	File ""${SRC_APPS_PATH}\lang\escfg_1033.lng
	File ""${SRC_APPS_PATH}\lang\escfg_2052.lng
	File "${SRC_APPS_PATH}\lang\escsp_1033.lng"
	File "${SRC_APPS_PATH}\lang\escsp_2052.lng"
	
	SetOutPath $SYSDIR
	SetOverwrite off
	File "${SRC_APPS_PATH}\MSVCP60.DLL"
	SetOverwrite try
	File "${SRC_APPS_PATH}\et199csp11.sig"
	File "${SRC_APPS_PATH}\et199csp11_s.dll"
	File "${SRC_APPS_PATH}\et199csp11.dll"
	File "${SRC_APPS_PATH}\et199Plugs.dll"
	
	ExecWait 'regedit.exe /s "$INSTDIR\et199csp11_s.reg"'
	RegDLL "$SYSDIR\et199Plugs.dll"
	Exec "$INSTDIR\escertd_et199.exe"
	
	WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Run" "escertd_et199" "$INSTDIR\escertd_et199.exe"
	
	;Create shortcuts
	StrCpy $0 "$SMPROGRAMS\${TARGET_DIR_BASE}"
	CreateDirectory $0
	CreateShortCut "$0\$(STR_LINK_MANAGER).lnk" "$INSTDIR\esmgr_et199.exe"
	CreateShortCut "$0\$(STR_LINK_CONFIG).lnk" "$INSTDIR\ConfigTool_et199.exe"
	CreateShortCut "$0\$(STR_LINK_UNINSTALLER).lnk" "$INSTDIR\uninst.exe"

	;עɹɾעļ
	Delete /REBOOTOK "$INSTDIR\et199csp11_s.reg"

	;------------------------------------
	;ܵ˵װѾɣMSVCP60.DLLļü
	;------------------------------------
	StrCpy $0 "$SYSDIR\msvcp60.dll"
	ReadRegDword $1 HKLM Software\Microsoft\Windows\CurrentVersion\SharedDLLs $0
	IntOp $1 $1 + 1
	WriteRegDWORD HKLM Software\Microsoft\Windows\CurrentVersion\SharedDLLs $0 $1

FunctionEnd



;-------------------------------------------------
; жмĺ
;-------------------------------------------------
Function un.InstMW

    ExecWait "$INSTDIR\escertd_et199.exe -t"
Start_Delete:
	Sleep 2000
	ClearErrors
    	Delete /REBOOTOK "$INSTDIR\escertd_et199.exe"
	IfErrors Start_Delete

	RMDir /r /REBOOTOK "$INSTDIR"
	RMDir "$PROGRAMFILES\${START_MENU_ROOT}"

	Delete /REBOOTOK "$SYSDIR\et199csp11_s.dll"
   	Delete /REBOOTOK "$SYSDIR\et199csp11.dll"
	Delete /REBOOTOK "$SYSDIR\et199csp11.sig"


    	DeleteRegKey HKLM "SOFTWARE\Microsoft\Cryptography\Defaults\Provider\EnterSafe ET199 CSP v1.0"
   	DeleteRegValue HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Run\" "escertd_et199"
    
	RMDir /r /REBOOTOK "$SMPROGRAMS\${TARGET_DIR_BASE}"
	RMDir "$SMPROGRAMS\${START_MENU_ROOT}"

	;------------------------------------
	;ߵ˵жɣٶMSVCP60.DLLļü.
	;------------------------------------
	StrCpy $0 "$SYSDIR\msvcp60.dll"
	ReadRegDword $1 HKLM Software\Microsoft\Windows\CurrentVersion\SharedDLLs $0
	IntOp $1 $1 - 1
	WriteRegDWORD HKLM Software\Microsoft\Windows\CurrentVersion\SharedDLLs $0 $1
FunctionEnd

; This text show at the bottom of the installer UI. Replace the "Nullsoft Install System vXXX".
BrandingText "Windows Installer"